#include "internal.h"
#include "gfx.h"
#include "math.c"

extern char had_fatal_error;

extern int want_scr_x,want_scr_y,want_scr_x2, want_scr_y2,have_want;

//extern int CountWalls, CountAreas, CountPoints;

//int    WTD_Working=FALSE;
//FIXED *FPSPtr;

void WTD_Init(void){
        maketables();

	InitMemory();			// Init mem.manager and get some mem
	InitEffects();			// Prepare effect tables
	LeftVDraw.LeftCol=LeftVDraw.RightCol=-10000;	// Init list
	RightVDraw.LeftCol=RightVDraw.RightCol=10000;	// Init list
	TotalFrames=0;			// Total frames drawn
        //WTD_Working=FALSE;              // Clear working flag
	Engine.MaxStairs=INT_FIX(32);	// Max stairs step height
        want_scr_x=want_scr_y=want_scr_x2=want_scr_y2=0;
        have_want=0;
}

extern FILE *td_debug_file;
void WTD_Config(int Width, int Height){
	FIXED t1,t2;
	int i;
//if(td_debug_file)fprintf(td_debug_file,"Fatal status %d\n",had_fatal_error);
//        if(had_fatal_error)return;

	Engine.ScrWidth=Width;		// Set screen width
	Engine.ScrHeight=Height;	// Set screen height
	t1=FixDiv(INT_FIX(320),INT_FIX(240));	// Ratio for square pixels
	t2=FixDiv(INT_FIX(Width),INT_FIX(Height)); // Our ratio
	Engine.ScrConst=FixDiv(t1,t2);	// Make ScrConst

        if (FLines) MemFree(FLines,"Config:FLines");    // Free FLines if necessary
        FLines=(struct FLine *)CacheAlloc(Height*sizeof(struct FLine),"Config:FLines");
        if (!FLines) { FatalError(ER_MEMORY,"TdConfigA");//,"FLines");
                        return; }
        if (VLines) MemFree(VLines,"Config:VLines");    // Free VLines if necessary
        VLines=(struct VLine *)CacheAlloc(MAX_LEVELS*Width*sizeof(struct VLine),"Config:VLines");
        if (!VLines) {FatalError(ER_MEMORY,"TdConfigB");//,"VLines");
                        return; }
	for(i=0;i<MAX_LEVELS*Width;i++)	// Init VLines
		VLines[i].Top=VLines[i].Bot=0;
	for(i=0;i<MAX_LEVELS;i++)	// Init Clip in Levels
		Levels[i].Clip=VLines+Width*i;
	Engine.PickX=-1;		// Init Pick X coord
	Engine.PickY=-1;		// Init Pick Y coord
return; }

/*void WTD_Start(void){
	SetPalette(Pal.VGAPal);		// Set palette
        //DrawScreen();                   // Fill the screen
        WTD_Working=TRUE;               // WTD is working
return; }*/

/*void WTD_Update(void){
        if (!WTD_Working) return;
        UpdateLevel(); // Update the zone
return; }*/

void WTD_Render(void){
	int i;
	struct View *pView;
        /*****************************/
        //CountWalls=CountAreas=CountPoints=0;
        /******************************/
        if(had_fatal_error)return;
        // Prepare pick checking
	Engine.PickPtr=NULL;
	Engine.PickType=PICK_NULL;
	Engine.PickDist=0;
	for(i=0;i<Views.Number;i++) {
                // Create general stamp for this frame for current view
		CurStamp=(TotalFrames<<7)+(i<<4);
		pView=(struct View *)Views.ptr[i];
                DrawView(pView);
                if(had_fatal_error)break;
                }
	TotalFrames++;
}

//void WTD_Stop(void){ WTD_Working=FALSE; return; }           // WTD is not working
//void WTD_Shut(void){ ShutMemory(); return;     }           // Shut down memory manager

/*void SetPickWatch(int x, int y){
	Engine.PickX=x;
	Engine.PickY=y;
return; }

WORD GetPickWatch(void *data, FIXED *dist){
	data=Engine.PickPtr;
	*dist=Engine.PickDist;
return(Engine.PickType); }*/

/*BYTE GetTrace(int *x1, int *y1, int *x2, int *y2){
	*x1=Engine.TraceX1;
	*y1=Engine.TraceY1;
	*x2=Engine.TraceX2;
	*y2=Engine.TraceY2;
return(Engine.TraceX1!=Engine.TraceX2); }*/

void RegisterEffect(char *name, void (*func)(void *,DWORD,DWORD),DWORD type){
	struct Effect *eff;

	eff=(struct Effect *)AddEntry(&Effects);
	strcpy(eff->Name,name);
	eff->func=func;
	eff->Type=type;
return; }

struct Effect *GetEffect(char *name, void *data){
	struct Effect *eff;
	int i;

// Remove from RTE list if needed
	DelRTEffect(data);
        if (stricmp(name,NULL_RES)==0) return NULL;
	for(i=0;i<Effects.Number;i++) {
		eff=(struct Effect *)Effects.ptr[i];
                if (stricmp(name,eff->Name)==0) {
	// Add to RTE list if needed
                        AddRTEffect(eff,data);
			return(eff);
		}
	}
        FatalError(ER_FIND,name);
	return NULL;
}

void AddRTEffect(struct Effect *eff, void *data)
{
	if (eff==NULL||(eff->Type&EFF_FRAME)==0) return;
        if (NumRTE>=RES_NUM){
                FatalError(ER_RES,"");//,NULL);
                return;
                }
	RTE[NumRTE].Eff=eff;
	RTE[NumRTE].data=data;
	NumRTE++;
}

void DelRTEffect(void *data)
{
	struct RTEffect *rt;
	int i;

	if (NumRTE<=0) return;

	rt=&RTE[NumRTE-1];
	for(i=NumRTE-1;i>=0;i--,rt--) {
		if (rt->data==data) break;
	}
	if (i<0) return;

	NumRTE--;
	*rt=RTE[NumRTE];
}

void ProcessEffect(struct Effect *eff, void *ptr, DWORD type, DWORD param){
	if (eff) {
                if ((eff->Type&type)!=0)eff->func(ptr,type,param);
                }
return; }

/*void ActivateTag(int tag)
{
        struct Wall   *w;
        struct Area *r;
	struct Object *o;
	int i;

	if (tag<0) return;

// TAGs are activated EVERYWHERE!!!
	for(i=0;i<Objects.Number;i++) {
		o=(struct Object *)Objects.ptr[i];
		if (o->Tag==tag)
			ProcessEffect(o->Eff,o,EFF_TAG,0);
	}
	for(i=0;i<Walls.Number;i++) {
		w=(struct Wall *)Walls.ptr[i];
		if (w->Tag==tag)
			ProcessEffect(w->Eff,w,EFF_TAG,0);
	}
        for(i=0;i<Areas.Number;i++) {
                r=(struct Area *)Areas.ptr[i];
		if (r->Tag==tag)
			ProcessEffect(r->Eff,r,EFF_TAG,0);
        }
}*/

/*void SetupEffects(DWORD type){
	struct Wall   *w;
        struct Area *r;
	struct Object *o;
	struct View   *v;
	int i;

// Process ALL resources
	for(i=0;i<Objects.Number;i++) {
		o=(struct Object *)Objects.ptr[i];
                if (o->Eff) o->Eff->func(o,type,0);
	}
	for(i=0;i<Walls.Number;i++) {
		w=(struct Wall *)Walls.ptr[i];
                if (w->Eff) w->Eff->func(w,type,0);
                }
        for(i=0;i<Areas.Number;i++) {
                r=(struct Area *)Areas.ptr[i];
		if (r->Eff)
			r->Eff->func(r,type,0);
	}
	for(i=0;i<Views.Number;i++) {
		v=(struct View *)Views.ptr[i];
		if (v->Eff)
			v->Eff->func(v,type,0);
	}
	if (Gen.BackEff)
		Gen.BackEff->func(NULL,type,0);
}


  */
